Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 468)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
@@ -6930,17 +8171,53 @@
       //////////////////////////
       case ALLOC_IVT_WRITE:            // allocated to WRITE FSM
-          if (r_write_fsm.read() != WRITE_BC_IVT_LOCK)
+          if ((r_write_fsm.read() != WRITE_BC_IVT_LOCK) and
+             (r_write_fsm.read() != WRITE_IVT_LOCK_HIT_WB) and
+             (r_write_fsm.read() != WRITE_MISS_IVT_LOCK))
           {
-              if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
-
-              else if (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
-
-              else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
+            if(r_read_fsm.read() == READ_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_READ;
+            
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+
+            else if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
+                    (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK_DATA))
+              r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+              
+            else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
                   r_alloc_ivt_fsm = ALLOC_IVT_CAS;
-
-              else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+        
+            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+
+            else
+              m_cpt_ivt_unused++;
+          }
+          break;
+
+      //////////////////////////
+      case ALLOC_IVT_READ:            // allocated to READ FSM
+          if (r_read_fsm.read() != READ_IVT_LOCK) 
+          {
+            if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+
+            else if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
+                    (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK_DATA))
+              r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+              
+            else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
+                  r_alloc_ivt_fsm = ALLOC_IVT_CAS;
+        
+            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+          
+            else if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
+                (r_write_fsm.read() == WRITE_IVT_LOCK_HIT_WB) or
+                (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
+              r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+
+            else
+              m_cpt_ivt_unused++;
           }
           break;
@@ -6950,15 +8227,24 @@
           if(r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK)
           {
-              if(r_cleanup_fsm.read() == CLEANUP_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
-
-              else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CAS;
-
-              else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
-
-              else if (r_write_fsm.read() == WRITE_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+            if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
+                (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK_DATA))
+              r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+
+            else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CAS;
+
+            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+
+            else if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
+                    (r_write_fsm.read() == WRITE_IVT_LOCK_HIT_WB) or
+                    (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
+              r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+
+            else if(r_read_fsm.read() == READ_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_READ;
+            
+            else
+              m_cpt_ivt_unused++;
           }
           break;
@@ -6967,17 +8253,26 @@
       case ALLOC_IVT_CLEANUP:          // allocated to CLEANUP FSM
           if ((r_cleanup_fsm.read() != CLEANUP_IVT_LOCK     ) and
-              (r_cleanup_fsm.read() != CLEANUP_IVT_DECREMENT))
+              (r_cleanup_fsm.read() != CLEANUP_IVT_DECREMENT) and
+              (r_cleanup_fsm.read() != CLEANUP_IVT_LOCK_DATA))
           {
-              if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CAS;
-
-              else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
-
-              else if (r_write_fsm.read() == WRITE_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
-
-              else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+            if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CAS;
+
+            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+
+            else if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
+                (r_write_fsm.read() == WRITE_IVT_LOCK_HIT_WB) or
+                (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
+              r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+
+            else if(r_read_fsm.read() == READ_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_READ;
+
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+
+            else
+              m_cpt_ivt_unused++;
           }
           break;
@@ -6987,15 +8282,24 @@
           if (r_cas_fsm.read() != CAS_BC_IVT_LOCK)
           {
-              if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
-
-              else if (r_write_fsm.read() == WRITE_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
-
-              else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
-
-              else if (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+            if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
+
+            else if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
+                (r_write_fsm.read() == WRITE_IVT_LOCK_HIT_WB) or
+                (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
+              r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+
+            else if(r_read_fsm.read() == READ_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_READ;
+
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+
+            else if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
+                (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK_DATA))
+              r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+
+            else
+              m_cpt_ivt_unused++;
           }
           break;
@@ -7005,20 +8309,28 @@
           if (r_config_fsm.read() != CONFIG_DIR_IVT_LOCK)
           {
-              if (r_write_fsm.read() == WRITE_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
-
-              else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
-
-              else if (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
-
-              else if (r_cas_fsm.read() == CAS_BC_IVT_LOCK)
-                  r_alloc_ivt_fsm = ALLOC_IVT_CAS;
+            if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
+                (r_write_fsm.read() == WRITE_IVT_LOCK_HIT_WB) or
+                (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
+              r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
+
+            else if(r_read_fsm.read() == READ_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_READ;
+
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
+
+            else if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
+                (r_cleanup_fsm.read() == CLEANUP_IVT_LOCK_DATA))
+              r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
+      
+            else if(r_cas_fsm.read() == CAS_BC_IVT_LOCK)
+              r_alloc_ivt_fsm = ALLOC_IVT_CAS;
+
+            else
+              m_cpt_ivt_unused++;
           }
           break;
-
   } // end switch r_alloc_ivt_fsm
-
+  
   ////////////////////////////////////////////////////////////////////////////////////
   //    ALLOC_DIR FSM
@@ -7073,5 +8385,6 @@
          (r_read_fsm.read()      != READ_DIR_LOCK)   and
          (r_read_fsm.read()      != READ_TRT_LOCK)   and
-         (r_read_fsm.read()      != READ_HEAP_REQ))
+         (r_read_fsm.read()      != READ_HEAP_REQ)   and
+         (r_read_fsm.read()      != READ_IVT_LOCK))
          or
          ((r_read_fsm.read()       == READ_TRT_LOCK)   and
@@ -7089,28 +8402,35 @@
         else if(r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)
           r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
-
+        
         else if(r_config_fsm.read() == CONFIG_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CONFIG;
-    }
-    break;
-
-    /////////////////////
-    case ALLOC_DIR_WRITE:    // allocated to WRITE FSM
-    if(((r_write_fsm.read()       != WRITE_DIR_REQ)  and
-        (r_write_fsm.read()       != WRITE_DIR_LOCK)  and
-        (r_write_fsm.read()       != WRITE_DIR_READ)  and
-        (r_write_fsm.read()       != WRITE_DIR_HIT)  and
-        (r_write_fsm.read()       != WRITE_BC_TRT_LOCK)  and
-        (r_write_fsm.read()       != WRITE_BC_IVT_LOCK)  and
-        (r_write_fsm.read()       != WRITE_MISS_TRT_LOCK)  and
-        (r_write_fsm.read()       != WRITE_UPT_LOCK)  and
-        (r_write_fsm.read()       != WRITE_UPT_HEAP_LOCK))
-        or
-        ((r_write_fsm.read()      == WRITE_UPT_HEAP_LOCK)  and
-         (r_alloc_heap_fsm.read() == ALLOC_HEAP_WRITE))
-        or
-        ((r_write_fsm.read()      == WRITE_MISS_TRT_LOCK)  and
-         (r_alloc_trt_fsm.read()  == ALLOC_TRT_WRITE)))
-    {
+
+        else
+          m_cpt_dir_unused++;
+      }
+      else
+        m_cpt_read_fsm_dir_used++;
+      break;
+
+      /////////////////////
+    case ALLOC_DIR_WRITE:
+      if(((r_write_fsm.read()       != WRITE_DIR_REQ)  and
+          (r_write_fsm.read()       != WRITE_DIR_LOCK)  and
+          (r_write_fsm.read()       != WRITE_DIR_READ)  and
+          (r_write_fsm.read()       != WRITE_DIR_HIT)  and
+          (r_write_fsm.read()       != WRITE_BC_TRT_LOCK)  and
+          (r_write_fsm.read()       != WRITE_BC_IVT_LOCK)  and
+          (r_write_fsm.read()       != WRITE_MISS_IVT_LOCK)  and
+          (r_write_fsm.read()       != WRITE_MISS_TRT_LOCK)  and
+          (r_write_fsm.read()       != WRITE_UPT_LOCK)  and
+          (r_write_fsm.read()       != WRITE_UPT_HEAP_LOCK) and
+          (r_write_fsm.read()       != WRITE_IVT_LOCK_HIT_WB))
+          or
+          ((r_write_fsm.read()      == WRITE_UPT_HEAP_LOCK)  and
+           (r_alloc_heap_fsm.read() == ALLOC_HEAP_WRITE))
+          or
+          ((r_write_fsm.read()      == WRITE_MISS_TRT_LOCK)  and
+           (r_alloc_trt_fsm.read()  == ALLOC_TRT_WRITE)))
+      {
         if(r_cas_fsm.read() == CAS_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CAS;
@@ -7127,10 +8447,15 @@
         else if(r_read_fsm.read() == READ_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_READ;
-    }
-    break;
+        
+        else
+          m_cpt_dir_unused++;
+      }
+      else
+        m_cpt_write_fsm_dir_used++;
+      break;
 
     ///////////////////
     case ALLOC_DIR_CAS:    // allocated to CAS FSM
-    if(((r_cas_fsm.read()         != CAS_DIR_REQ)  and
+      if(((r_cas_fsm.read()         != CAS_DIR_REQ)  and
         (r_cas_fsm.read()         != CAS_DIR_LOCK)  and
         (r_cas_fsm.read()         != CAS_DIR_HIT_READ)  and
@@ -7148,5 +8473,5 @@
         ((r_cas_fsm.read()        == CAS_MISS_TRT_LOCK)  and
          (r_alloc_trt_fsm.read()  == ALLOC_TRT_CAS)))
-    {
+      {
         if(r_cleanup_fsm.read() == CLEANUP_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
@@ -7163,14 +8488,20 @@
         else if(r_write_fsm.read() == WRITE_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_WRITE;
-    }
-      break;
-
+        
+        else
+          m_cpt_dir_unused++;
+      }
+      else
+        m_cpt_cas_fsm_dir_used++;
+      break;
+      
     ///////////////////////
     case ALLOC_DIR_CLEANUP:    // allocated to CLEANUP FSM
-    if((r_cleanup_fsm.read() != CLEANUP_DIR_REQ) and
+      if((r_cleanup_fsm.read() != CLEANUP_DIR_REQ) and
         (r_cleanup_fsm.read() != CLEANUP_DIR_LOCK) and
         (r_cleanup_fsm.read() != CLEANUP_HEAP_REQ) and
-        (r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK))
-    {
+        (r_cleanup_fsm.read() != CLEANUP_HEAP_LOCK) and
+        (r_cleanup_fsm.read() != CLEANUP_IVT_LOCK_DATA))
+      {
         if(r_xram_rsp_fsm.read() == XRAM_RSP_DIR_LOCK)
           r_alloc_dir_fsm = ALLOC_DIR_XRAM_RSP;
@@ -7187,13 +8518,18 @@
         else if(r_cas_fsm.read() == CAS_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CAS;
-    }
-    break;
+
+        else
+          m_cpt_dir_unused++;
+      }
+      else
+        m_cpt_cleanup_fsm_dir_used++;
+      break;
 
     ////////////////////////
     case ALLOC_DIR_XRAM_RSP:    // allocated to XRAM_RSP FSM
-    if( (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK) and
+      if( (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK) and
         (r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY) and
         (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK))
-    {
+      {
         if(r_config_fsm.read() == CONFIG_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CONFIG;
@@ -7210,6 +8546,11 @@
         else if(r_cleanup_fsm.read() == CLEANUP_DIR_REQ)
           r_alloc_dir_fsm = ALLOC_DIR_CLEANUP;
-    }
-    break;
+
+        else
+          m_cpt_dir_unused++;
+      }
+      else
+        m_cpt_xram_rsp_fsm_dir_used++;
+      break;
 
   } // end switch alloc_dir_fsm
@@ -7245,5 +8586,13 @@
                 (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-      }
+
+        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+        else
+          m_cpt_trt_unused++;
+      }
+      else
+        m_cpt_read_fsm_trt_used++;
       break;
 
@@ -7265,8 +8614,16 @@
                 (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+        
+        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
         else if(r_read_fsm.read() == READ_TRT_LOCK)
           r_alloc_trt_fsm = ALLOC_TRT_READ;
-      }
+
+        else
+          m_cpt_trt_unused++;
+      }
+      else
+        m_cpt_write_fsm_trt_used++;
       break;
 
@@ -7284,4 +8641,7 @@
                 (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+        
+        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
         else if(r_read_fsm.read() == READ_TRT_LOCK)
@@ -7291,5 +8651,10 @@
                 (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
           r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-      }
+
+        else
+          m_cpt_trt_unused++;
+      }
+      else
+        m_cpt_cas_fsm_trt_used++;
       break;
 
@@ -7305,4 +8670,7 @@
             (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+        
+        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
         else if(r_read_fsm.read() == READ_TRT_LOCK)
@@ -7316,5 +8684,10 @@
                 (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
-      }
+
+        else
+          m_cpt_trt_unused++;
+      }
+      else
+        m_cpt_xram_rsp_fsm_trt_used++;
       break;
 
@@ -7324,4 +8697,35 @@
           (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ))
       {
+        
+        if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+        else if(r_read_fsm.read() == READ_TRT_LOCK)
+          r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) ||
+                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+        else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) ||
+                (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+          r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) &&
+                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+        else
+          m_cpt_trt_unused++;
+      }
+      else
+        m_cpt_ixr_fsm_trt_used++;
+      break;
+
+      ////////////////////////
+    case ALLOC_TRT_CLEANUP:
+      /*ODCCP*///std::cout << "TRT ALLOCATED TO CLEANUP" << std::endl;
+      if(r_cleanup_fsm.read() != CLEANUP_IXR_REQ)
+      {
         if(r_read_fsm.read() == READ_TRT_LOCK)
           r_alloc_trt_fsm = ALLOC_TRT_READ;
@@ -7338,4 +8742,8 @@
                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
           r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+        else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
+            (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
       }
       break;
@@ -7388,5 +8796,10 @@
         else if(r_config_fsm.read() == CONFIG_HEAP_REQ)
           r_alloc_heap_fsm = ALLOC_HEAP_CONFIG;
-      }
+
+        else
+          m_cpt_heap_unused++;
+      }
+      else
+        m_cpt_read_fsm_heap_used++;
       break;
 
@@ -7411,5 +8824,10 @@
         else if(r_read_fsm.read() == READ_HEAP_REQ)
           r_alloc_heap_fsm = ALLOC_HEAP_READ;
-      }
+
+        else
+          m_cpt_heap_unused++;
+      }
+      else
+        m_cpt_write_fsm_heap_used++;
       break;
 
@@ -7434,5 +8852,10 @@
         else if(r_write_fsm.read() == WRITE_UPT_HEAP_LOCK)
           r_alloc_heap_fsm = ALLOC_HEAP_WRITE;
-      }
+
+        else
+          m_cpt_heap_unused++;
+      }
+      else
+        m_cpt_cas_fsm_heap_used++;
       break;
 
@@ -7458,5 +8881,10 @@
         else if(r_cas_fsm.read() == CAS_UPT_HEAP_LOCK)
           r_alloc_heap_fsm = ALLOC_HEAP_CAS;
-      }
+
+        else
+          m_cpt_heap_unused++;
+      }
+      else
+        m_cpt_cleanup_fsm_heap_used++;
       break;
 
@@ -7503,5 +8931,10 @@
         if(r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ)
           r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
-      }
+
+        else
+          m_cpt_heap_unused++;
+      }
+      else
+        m_cpt_xram_rsp_fsm_heap_used++;
       break;
 
@@ -7563,7 +8996,25 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  m_cc_receive_to_cleanup_fifo.update( cc_receive_to_cleanup_fifo_get,
-                                       cc_receive_to_cleanup_fifo_put, 
-                                       p_dspin_p2m.data.read() );
+  if(cc_receive_to_cleanup_fifo_put)
+  {
+    if(cc_receive_to_cleanup_fifo_get)
+    {
+      m_cc_receive_to_cleanup_fifo.put_and_get( ((uint64_t)(p_dspin_p2m.eop.read()&0x1) << 32) | p_dspin_p2m.data.read() );
+    }
+    else
+    {
+      m_cc_receive_to_cleanup_fifo.simple_put( ((uint64_t)(p_dspin_p2m.eop.read()&0x1) << 32) | p_dspin_p2m.data.read() );
+    }
+  }
+  else
+  {
+    if(cc_receive_to_cleanup_fifo_get)
+    {
+      m_cc_receive_to_cleanup_fifo.simple_get();
+    }
+  }
+  //m_cc_receive_to_cleanup_fifo.update( cc_receive_to_cleanup_fifo_get,
+  //                                     cc_receive_to_cleanup_fifo_put, 
+  //                                     p_dspin_p2m.data.read() );
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -7714,4 +9165,26 @@
     p_vci_ixr.trdid     = r_xram_rsp_to_ixr_cmd_trdid.read();
     p_vci_ixr.eop       = (r_ixr_cmd_cpt == (m_words-2));
+  } 
+  else if (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_DATA)
+  {
+    p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
+    p_vci_ixr.cmdval  = true;
+    p_vci_ixr.address = (addr_t)((r_cleanup_to_ixr_cmd_nline.read() * m_words + r_ixr_cmd_cpt.read()) * 4);
+    if (r_cleanup_to_ixr_cmd_ncc_l1_dirty.read()) //if L1 was dirty, the correct data is in the cleanup
+    {
+      p_vci_ixr.wdata   = ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
+          ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
+      if(r_cleanup_to_ixr_cmd_nline.read() == 0x12bb)
+        std::cout << "IXR data dirty = " << std::hex << p_vci_ixr.wdata << std::dec << std::endl;
+    }
+    else //if L1 was not dirty, the data is in the L2
+    {
+      p_vci_ixr.wdata   = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
+          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
+      if(r_cleanup_to_ixr_cmd_nline.read() == 0x12bb)
+        std::cout << "IXR data not dirty = " << std::hex << p_vci_ixr.wdata << std::dec << std::endl;
+    }
+    p_vci_ixr.trdid   = r_cleanup_to_ixr_cmd_trdid.read();
+    p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words - 2));
   }
   else
@@ -7857,12 +9330,29 @@
 
     case TGT_RSP_CLEANUP:
+    {
+      uint32_t last_word_idx = r_cleanup_to_tgt_rsp_first_word.read() + r_cleanup_to_tgt_rsp_length - 1;
+      bool     is_last_word  = (r_tgt_rsp_cpt.read() == last_word_idx);
+      bool     is_ll         = ((r_cleanup_to_tgt_rsp_pktid.read() & 0x7) == TYPE_LL);
+
       p_vci_tgt.rspval   = true;
-      p_vci_tgt.rdata    = 0;
+      if (is_ll and not r_tgt_rsp_key_sent.read())
+      {
+        p_vci_tgt.rdata   = r_cleanup_to_tgt_rsp_ll_key.read();
+      }
+      else if (!r_cleanup_to_tgt_rsp_type.read())
+      {
+        p_vci_tgt.rdata    = r_cleanup_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read();
+      }
+      else  //if the CLEANUP fsm sends a SC_RSP, then it is a success (and it caused an inval)
+      {
+        p_vci_tgt.rdata    = 0;
+      }
       p_vci_tgt.rsrcid   = r_cleanup_to_tgt_rsp_srcid.read();
       p_vci_tgt.rtrdid   = r_cleanup_to_tgt_rsp_trdid.read();
       p_vci_tgt.rpktid   = r_cleanup_to_tgt_rsp_pktid.read();
       p_vci_tgt.rerror   = 0; // Can be a CAS rsp
-      p_vci_tgt.reop     = true;
-      break;
+      p_vci_tgt.reop     = r_cleanup_to_tgt_rsp_type.read() or (is_last_word and not is_ll) or (r_tgt_rsp_key_sent.read() and is_ll);
+      break;
+    }
 
     case TGT_RSP_CAS:
@@ -7885,9 +9375,11 @@
       p_vci_tgt.rspval  = true;
 
-      if( is_ll and not r_tgt_rsp_key_sent.read() ) {
+      if( is_ll and not r_tgt_rsp_key_sent.read() ) 
+      {
         // LL response first flit
         p_vci_tgt.rdata = r_xram_rsp_to_tgt_rsp_ll_key.read();
       }
-      else {
+      else 
+      {
         // LL response second flit or READ response
         p_vci_tgt.rdata = r_xram_rsp_to_tgt_rsp_data[r_tgt_rsp_cpt.read()].read();
@@ -7900,4 +9392,5 @@
       p_vci_tgt.reop    = (((is_last_word or is_error) and not is_ll) or
                             (r_tgt_rsp_key_sent.read() and     is_ll));
+
       break;
     }
@@ -8081,4 +9574,105 @@
     }
     /////////////////////////////////
+
+  case CC_SEND_READ_NCC_INVAL_HEADER:
+    {
+      uint64_t flit = 0;
+
+      uint8_t multi_inval_type;
+      if (r_read_to_cc_send_inst.read())
+      {
+        multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_INST;
+      }
+      else
+      {
+        multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_DATA;
+      }
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          r_read_to_cc_send_dest.read(),
+          DspinDhccpParam::MULTI_INVAL_DEST);
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          m_cc_global_id,
+          DspinDhccpParam::MULTI_INVAL_SRCID);
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          DspinDhccpParam::TYPE_MULTI_INVAL_DATA,
+          DspinDhccpParam::M2P_TYPE);
+
+      p_dspin_m2p.write = true;
+      p_dspin_m2p.data  = flit;
+
+      break;
+
+    }
+
+
+    case CC_SEND_READ_NCC_INVAL_NLINE:
+    {
+      uint64_t flit = 0;
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          r_read_to_cc_send_nline.read(),
+          DspinDhccpParam::MULTI_INVAL_NLINE);
+
+
+      p_dspin_m2p.write = true;
+      p_dspin_m2p.data  = flit;
+      p_dspin_m2p.eop   = true;
+
+      break;
+
+    }
+
+    case CC_SEND_WRITE_NCC_INVAL_HEADER:
+    {
+      uint64_t flit = 0;
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          r_write_to_cc_send_dest.read(),
+          DspinDhccpParam::MULTI_INVAL_DEST);
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          m_cc_global_id,
+          DspinDhccpParam::MULTI_INVAL_SRCID);
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          DspinDhccpParam::TYPE_MULTI_INVAL_DATA,
+          DspinDhccpParam::M2P_TYPE);
+
+      p_dspin_m2p.write = true;
+      p_dspin_m2p.data  = flit;
+
+      break;
+
+    }
+
+    case CC_SEND_WRITE_NCC_INVAL_NLINE:
+    {
+      uint64_t flit = 0;
+
+      DspinDhccpParam::dspin_set(
+          flit,
+          r_write_to_cc_send_nline.read(),
+          DspinDhccpParam::MULTI_INVAL_NLINE);
+
+
+      p_dspin_m2p.write = true;
+      p_dspin_m2p.data  = flit;
+      p_dspin_m2p.eop   = true;
+
+      break;
+
+    }
+
+
     case CC_SEND_WRITE_BRDCAST_NLINE:
     {
